gtkmm: Gtk::Buildable Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::Buildable Class Reference

A base class for objects that can be built by Gtk::Builder. More...

`#include <gtkmm/buildable.h>`

Inheritance diagram for Gtk::Buildable:
[legend]

## Public Member Functions
| Buildable (Buildable &&src) noexcept
Buildable & | operator= (Buildable &&src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Buildable ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A base class for objects that can be built by Gtk::Builder.

Buildable allows objects to extend and customize thier deserialization from Gtk::Builder UI descriptions. The interface includes methods for setting names and properties of objects, parsing custom tags and constructing child objects.

All gtkmm widgets, and many non-widget objects, derive from this base class. The main user of this interface is Gtk::Builder. There should be very little need for applications to call any of Buildable's methods.

Since gtkmm 3.0

## Constructor & Destructor Documentation

## ◆ Buildable() [1/2]

Gtk::Buildable::Buildable | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Buildable() [2/2]

Gtk::Buildable::Buildable | ( | Buildable && | src | ) |
| noexcept

## ◆ ~Buildable()

Gtk::Buildable::~Buildable | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::Buildable::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_buildable_id()

Glib::ustring Gtk::Buildable::get_buildable_id | ( |  | ) | const

Gets the ID of the buildable object.

`Gtk::Builder` sets the name based on the ID attribute of the `<object>` tag used to construct the buildable.

Returns
  The ID of the buildable object.

## ◆ get_type()

static GType Gtk::Buildable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkBuildable * Gtk::Buildable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkBuildable * Gtk::Buildable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

Buildable & Gtk::Buildable::operator= | ( | Buildable && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Buildable > wrap | ( | GtkBuildable * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.